%global githash e1bf0275e80c

Name:          openrdf-sesame
# Newer release require springframework >= 4.1.4.RELEASE
Version:       2.8.10
Release:       2%{?dist}
Summary:       Java framework for processing and handling RDF data
License:       BSD
URL:           http://rdf4j.org/
Source0:       https://bitbucket.org/openrdf/sesame/get/sesame-%{version}.tar.bz2
# Add servlet 3.1 methods
Patch0:        openrdf-sesame-2.8.4-servlet.patch
# Add jackson-core 2.5+ support
Patch1:        openrdf-sesame-2.8.4-jackson.patch

BuildRequires: maven-local
BuildRequires: mvn(cglib:cglib)
BuildRequires: mvn(ch.qos.logback:logback-classic)
BuildRequires: mvn(ch.qos.logback:logback-core)
BuildRequires: mvn(com.fasterxml.jackson.core:jackson-core)
BuildRequires: mvn(com.github.jsonld-java:jsonld-java)
BuildRequires: mvn(com.google.guava:guava)
BuildRequires: mvn(com.spatial4j:spatial4j)
BuildRequires: mvn(commons-cli:commons-cli)
BuildRequires: mvn(commons-codec:commons-codec)
BuildRequires: mvn(commons-dbcp:commons-dbcp)
BuildRequires: mvn(commons-io:commons-io)
BuildRequires: mvn(javax.servlet:javax.servlet-api)
BuildRequires: mvn(javax.servlet:jstl)
BuildRequires: mvn(javax.servlet.jsp:jsp-api)
BuildRequires: mvn(junit:junit)
# opencsv:3.2 https://bugzilla.redhat.com/show_bug.cgi?id=1241752
BuildRequires: mvn(net.sf.opencsv:opencsv)
BuildRequires: mvn(mysql:mysql-connector-java)
BuildRequires: mvn(org.apache.felix:maven-bundle-plugin)
BuildRequires: mvn(org.apache.httpcomponents:httpclient)
BuildRequires: mvn(org.apache.lucene:lucene-core:3)
BuildRequires: mvn(org.apache.lucene:lucene-highlighter:3)
BuildRequires: mvn(org.apache.lucene:lucene-queries:3)
BuildRequires: mvn(org.apache.lucene:lucene-spatial:3)
BuildRequires: mvn(org.apache.maven.plugins:maven-antrun-plugin)
BuildRequires: mvn(org.apache.maven.plugins:maven-assembly-plugin)
BuildRequires: mvn(org.apache.maven.plugins:maven-project-info-reports-plugin)
BuildRequires: mvn(org.apache.santuario:xmlsec)
BuildRequires: mvn(org.apache.taglibs:taglibs-standard-spec)
BuildRequires: mvn(org.hamcrest:hamcrest-library)
BuildRequires: mvn(org.mapdb:mapdb)
BuildRequires: mvn(org.mockito:mockito-core)
BuildRequires: mvn(org.slf4j:jcl-over-slf4j)
BuildRequires: mvn(org.slf4j:slf4j-api)
BuildRequires: mvn(org.sonatype.oss:oss-parent:pom:)
BuildRequires: mvn(org.springframework:spring-aop)
BuildRequires: mvn(org.springframework:spring-webmvc)
BuildRequires: mvn(postgresql:postgresql)
BuildRequires: mvn(xalan:xalan)
BuildRequires: mvn(jakarta-regexp:jakarta-regexp)

BuildArch:     noarch

%description
Sesame is an extensible Java framework for storing, querying and
inferencing for RDF. It can be deployed as a web server or used as
a Java library. Features include several query languages (SeRQL and
SPARQL), inferencing support, and RAM or disk storage. Additionally,
the central APIs of Sesame are storage-independent and are supported by
many third-party RDF database vendors.

%package bom
Summary:       OpenRDF Sesame BOM POM

%description bom
Sesame Bill of Materials (BOM) POM.

%package config
Summary:       OpenRDF Sesame: application configuration

%description config
Sesame application configuration classes.

%package console
Summary:       OpenRDF Sesame: Console

%description console
Command line user interface to Sesame repositories.

%package core-parent
Summary:       OpenRDF Sesame Core Parent POM

%description core-parent
Sesame Core Parent POM.

%package http
Summary:       OpenRDF Sesame: HTTP Parent POM

%description http
Sesame HTTP Parent POM.

%package http-client
Summary:       OpenRDF Sesame: HTTP client

%description http-client
Client functionality for communicating with an OpenRDF server over HTTP.

%package http-protocol
Summary:       OpenRDF Sesame: HTTP protocol

%description http-protocol
Sesame HTTP protocol (REST-style).

%package http-server-spring
Summary:       OpenRDF Sesame: HTTP server - core

%description http-server-spring
Sesame HTTP server implementing a REST-style protocol.

%package model
Summary:       OpenRDF Sesame: Model

%description model
Sesame RDF model interfaces and implementations.

%package parent
Summary:       OpenRDF Sesame Parent POM

%description parent
OpenRDF Sesame Parent POM.

%package query
Summary:       OpenRDF Sesame: Query

%description query
Sesame Query interfaces and implementations.

%package queryalgebra
Summary:       OpenRDF Sesame: Query algebra Parent POM

%description queryalgebra
Sesame Query algebra model and evaluation Parent POM.

%package queryalgebra-evaluation
Summary:       OpenRDF Sesame: Query algebra - Evaluation

%description queryalgebra-evaluation
Sesame Evaluation strategy API and
implementations for the query algebra model.

%package queryalgebra-geosparql
Summary:       OpenRDF Sesame: Query algebra - GeoSPARQL

%description queryalgebra-geosparql
Sesame Query algebra implementations to support the
evaluation of GeoSPARQL.

%package queryalgebra-model
Summary:       OpenRDF Sesame: Query algebra - Model

%description queryalgebra-model
Sesame generic query algebra for RDF queries.

%package queryparser
Summary:       OpenRDF Sesame: Query parser Parent POM

%description queryparser
Sesame Query parser API and implementations Parent POM.

%package queryparser-api
Summary:       OpenRDF Sesame: Query parser - API

%description queryparser-api
Sesame Query language parsers API.

%package queryparser-serql
Summary:       OpenRDF Sesame: Query parser - SeRQL

%description queryparser-serql
Sesame Query language parser implementation for SeRQL.

%package queryparser-sparql
Summary:       OpenRDF Sesame: Query parser - SPARQL

%description queryparser-sparql
Sesame Query language parser implementation for SPARQL.

%package queryrender
Summary:       OpenRDF Sesame: Query Rendering

%description queryrender
Sesame Query Render and Builder tools.

%package queryresultio
Summary:       OpenRDF Sesame: Query result IO Parent POM

%description queryresultio
Sesame Query result IO API and implementations Parent POM.

%package queryresultio-api
Summary:       OpenRDF Sesame: Query result IO - API

%description queryresultio-api
Sesame Query result IO API.

%package queryresultio-binary
Summary:       OpenRDF Sesame: Query result IO - binary

%description queryresultio-binary
Sesame Query result parser and writer implementation
for OpenRDF's binary query results format.

%package queryresultio-sparqljson
Summary:       OpenRDF Sesame: Query result IO - SPARQL/JSON

%description queryresultio-sparqljson
Sesame Query result writer implementation for the
SPARQL Query Results JSON Format.

%package queryresultio-sparqlxml
Summary:       OpenRDF Sesame: Query result IO - SPARQL/XML

%description queryresultio-sparqlxml
Sesame Query result parser and writer implementation for the
SPARQL Query Results XML Format.

%package queryresultio-text
Summary:       OpenRDF Sesame: Query result IO - plain text booleans

%description queryresultio-text
Sesame Query result parser and writer implementation
for OpenRDF's plain text boolean query results format.

%package repository
Summary:       OpenRDF Sesame: Repository Parent POM

%description repository
Sesame Repository API and implementations Parent POM.

%package repository-api
Summary:       OpenRDF Sesame: Repository - API

%description repository-api
Sesame API for interacting with repositories of RDF data.

%package repository-contextaware
Summary:       OpenRDF Sesame: Repository - context aware (wrapper)

%description repository-contextaware
Sesame Implementation that allows default values to
be set on a wrapped repository.

%package repository-dataset
Summary:       OpenRDF Sesame: DatasetRepository (wrapper)

%description repository-dataset
Sesame Implementation that loads all referenced datasets
into a wrapped repository.

%package repository-event
Summary:       OpenRDF Sesame: Repository - event (wrapper)

%description repository-event
Sesame Implementation that notifies listeners of
events on a wrapped repository.

%package repository-http
Summary:       OpenRDF Sesame: HTTPRepository

%description repository-http
Sesame "Virtual" repository that communicates with
a (remote) repository over the HTTP protocol.

%package repository-manager
Summary:       OpenRDF Sesame: Repository manager

%description repository-manager
Sesame Repository manager.

%package repository-sail
Summary:       OpenRDF Sesame: SailRepository

%description repository-sail
Sesame Repository that uses a Sail stack.

%package repository-sparql
Summary:       OpenRDF Sesame: SPARQL Repository

%description repository-sparql
The SPARQL Repository provides a Sesame Repository interface
to any SPARQL end-point.

%package rio
Summary:       OpenRDF Sesame: Rio Parent POM

%description rio
Sesame Rio (RDF I/O) is an API for parsers and
writers of various RDF file formats.

%package rio-api
Summary:       OpenRDF Sesame: Rio - API

%description rio-api
Sesame Rio API.

%package rio-binary
Summary:       OpenRDF Sesame: Rio - Binary

%description rio-binary
Sesame Rio parser and writer implementation for the
binary RDF file format.

%package rio-datatypes
Summary:       OpenRDF Sesame: Rio - Datatypes

%description rio-datatypes
Sesame Rio Datatype handler implementations.

%package rio-jsonld
Summary:       OpenRDF Sesame: Rio - JSON-LD

%description rio-jsonld
Sesame Rio parser and writer implementation for the
JSON-LD file format.

%package rio-languages
Summary:       OpenRDF Sesame: Rio - Languages

%description rio-languages
Sesame Rio Language handler implementations.

%package rio-n3
Summary:       OpenRDF Sesame: Rio - N3 (writer-only)

%description rio-n3
Sesame Rio writer implementation for the
N3 file format.

%package rio-nquads
Summary:       OpenRDF Sesame: Rio - N-Quads

%description rio-nquads
Sesame Rio parser and writer implementation for the
N-Quads file format.

%package rio-ntriples
Summary:       OpenRDF Sesame: Rio - N-Triples

%description rio-ntriples
Sesame Rio parser and writer implementation for the
N-Triples file format.

%package rio-rdfjson
Summary:       OpenRDF Sesame: Rio - RDF/JSON

%description rio-rdfjson
Sesame Rio parser and writer implementation for the
RDF/JSON file format.

%package rio-rdfxml
Summary:       OpenRDF Sesame: Rio - RDF/XML

%description rio-rdfxml
Sesame Rio parser and writer implementation for the
RDF/XML file format.

%package rio-trig
Summary:       OpenRDF Sesame: Rio - TriG

%description rio-trig
Sesame Rio parser and writer implementation for the
TriG file format.

%package rio-trix
Summary:       OpenRDF Sesame: Rio - TriX

%description rio-trix
Sesame Rio parser and writer implementation for the
TriX file format.

%package rio-turtle
Summary:       OpenRDF Sesame: Rio - Turtle

%description rio-turtle
Sesame Rio parser and writer implementation for the
Turtle file format.

%package runtime
Summary:       OpenRDF Sesame: Runtime

%description runtime
Sesame Runtime dependencies for an OpenRDF application.

%package runtime-osgi
Summary:       OpenRDF Sesame: Runtime - OSGi

%description runtime-osgi
Sesame OSGi Runtime dependencies for an OpenRDF application.

%package sail
Summary:       OpenRDF Sesame: Sail Parent POM

%description sail
Sesame Sail API and implementations Parent POM.

%package sail-api
Summary:       OpenRDF Sesame: Sail API

%description sail-api
Sesame RDF Storage And Inference Layer ("Sail") API.

%package sail-base
Summary:       OpenRDF Sesame: Sail base implementations

%description sail-base
Sesame RDF Storage And Inference Layer ("Sail") API.

%package sail-federation
Summary:       OpenRDF Sesame: Federation SAIL

%description sail-federation
The Federation SAIL allows multiple datasets to
be virtually combined into a single dataset. The
Federation SAIL combines multiple RDF stores that
may exist on a remote server or are embedded in the
same JVM. The Federation uses query optimizations to
distribute sections of the query to different members
based on the data contained in each of the members.
These results are then joined together within the
federation to provide the same result as if all the
data was co-located within a single repository

%package sail-fts
Summary:       OpenRDF Sesame: Text Search (FTS) Sails Parent POM

%description sail-fts
Full Text Search (lucene-based) API and implementations Parent POM.

%package sail-inferencer
Summary:       OpenRDF Sesame: Inferencer Sails

%description sail-inferencer
Sesame Stackable Sail implementation that adds RDF Schema
inferencing to an RDF store.

%package sail-lucene-api
Summary:       OpenRDF Sesame: Lucene Sail API

%description sail-lucene-api
Sesame StackableSail API offering full-text search on literals,
based on Apache Lucene.

%package sail-lucenesail
Summary:       OpenRDF Sesame: Lucene 3 Sail Index

%description sail-lucenesail
Sesame StackableSail implementation offering full-text search
on literals, based on Apache Lucene 3.

%package sail-memory
Summary:       OpenRDF Sesame: MemoryStore

%description sail-memory
Sesame Sail implementation that stores data in main memory,
optionally using a dump-restore file for persistence.

%package sail-model
Summary:       OpenRDF Sesame: Sail Model

%description sail-model
Sesame Sail implementation of Model.

%package sail-nativerdf
Summary:       OpenRDF Sesame: NativeStore

%description sail-nativerdf
Sesame Sail implementation that stores data directly to
disk in dedicated file formats.

%package sail-rdbms
Summary:       OpenRDF Sesame: RDBMS Sail

%description sail-rdbms
Sesame Sail implementation that stores data in a relational database.

%package testsuites
Summary:       OpenRDF Sesame test suites Parent POM

%description testsuites
OpenRDF Sesame test suites Parent POM.

%package geosparql-testsuite
Summary:       OpenRDF GeoSPARQL compliance test suite

%description geosparql-testsuite
Sesame Test suite for the GeoSPARQL query language.

%package lucene-testsuite
Summary:       OpenRDF Lucene Sail Tests

%description lucene-testsuite
Sesame generic tests for Lucene Sail implementations.

%package model-testsuite
Summary:       OpenRDF Model API compliance test suite

%description model-testsuite
Sesame Test suite for Model API.

%package queryresultio-testsuite
Summary:       OpenRDF Query Result IO compliance test suite

%description queryresultio-testsuite
Sesame Test suite for Query Result IO.

%package rio-testsuite
Summary:       OpenRDF Rio compliance test suite

%description rio-testsuite
Sesame Test suite for Rio.

%package serql-testsuite
Summary:       OpenRDF SeRQL test suite

%description serql-testsuite
Sesame Test suite for the SeRQL query language.

%package sparql-testsuite
Summary:       OpenRDF SPARQL compliance test suite

%description sparql-testsuite
Sesame Test suite for the SPARQL query language.

%package store-testsuite
Summary:       OpenRDF SAIL and Repository API compliance test suite

%description store-testsuite
Sesame Test suite for SAIL and Repository API.

%package util
Summary:       OpenRDF Sesame: util

%description util
Sesame utility classes.

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -n %{name}-%{githash}
# Cleanup
find . -name "*.class" -delete
find . -name "*.jar" -print -delete

%patch0 -p1
%patch1 -p1

# org.apache.maven.wagon:wagon-ssh-external:1.0-beta-7
%pom_xpath_remove "pom:build/pom:extensions"
%pom_remove_plugin -r :animal-sniffer-maven-plugin
%pom_remove_plugin -r :maven-eclipse-plugin
%pom_remove_plugin -r :maven-enforcer-plugin

%pom_disable_module assembly core
# Unsupported features (war)
%pom_disable_module workbench core/http
# Use com.github.ziplet:ziplet:2.0.0 org.tuckey:urlrewritefilter:4.0.4
%pom_disable_module server core/http
# Test only
%pom_disable_module compliance
# Use lucene:4.10.4
%pom_disable_module lucene4 core/sail/fts
%pom_remove_dep :sesame-sail-lucene4 bom
%pom_remove_dep :sesame-sail-lucene4 core/runtime
# Use elasticsearch:1.7.0
%pom_disable_module elasticsearch core/sail/fts
%pom_remove_dep :sesame-sail-elasticsearch bom
# Use solr:5.1.0 lucene:5.1.0
%pom_disable_module lucene core/sail/fts
%pom_disable_module solr core/sail/fts
%pom_remove_dep :sesame-sail-solr bom

# Use com.opencsv:opencsv:3.2
%pom_change_dep com.opencsv: net.sf.opencsv:opencsv:2.3 core/queryresultio/text
sed -i.old_opencsv "s|com.opencsv|au.com.bytecode.opencsv|" \
 core/queryresultio/text/src/main/java/org/openrdf/query/resultio/text/csv/SPARQLResultsCSVParser.java

%pom_xpath_set "pom:properties/pom:lucene.version" 3 core/sail/fts/lucenesail

%pom_remove_dep -r javax.activation:activation
%pom_remove_dep -r org.tuckey:urlrewritefilter
%pom_change_dep -r taglibs:standard org.apache.taglibs:taglibs-standard-spec:1.2.5

# Force servlet 3.1 apis
%pom_change_dep -r :servlet-api :javax.servlet-api:3.1.0
# Update xml-security references
%pom_change_dep -r :xmlsec org.apache.santuario:xmlsec:2.0.4

# Remove classpath from manifest
%pom_xpath_set "pom:addClasspath" false core/console

# InstantiationException: null in HashFunctionTest
rm -r core/queryalgebra/evaluation/src/test/java/org/openrdf/query/algebra/evaluation/function/hash/*

# UnknownHostException: www.w3.org
rm -r core/rio/turtle/src/test/java/org/openrdf/rio/turtle/TestTurtleParser.java

%build

%mvn_build -s

%install
%mvn_install

%files bom -f .mfiles-sesame-bom
%license core/LICENSE.txt core/NOTICE.txt

%files config -f .mfiles-sesame-config
%files console -f .mfiles-sesame-console

%files core-parent -f .mfiles-sesame-core

%files http -f .mfiles-sesame-http
%files http-client -f .mfiles-sesame-http-client
%files http-protocol -f .mfiles-sesame-http-protocol
%files http-server-spring -f .mfiles-sesame-http-server-spring

%files model -f .mfiles-sesame-model

%files parent -f .mfiles-sesame
%license core/LICENSE.txt core/NOTICE.txt

%files query -f .mfiles-sesame-query

%files queryalgebra -f .mfiles-sesame-queryalgebra
%files queryalgebra-evaluation -f .mfiles-sesame-queryalgebra-evaluation
%files queryalgebra-geosparql -f .mfiles-sesame-queryalgebra-geosparql
%files queryalgebra-model -f .mfiles-sesame-queryalgebra-model

%files queryparser -f .mfiles-sesame-queryparser
%files queryparser-api -f .mfiles-sesame-queryparser-api
%files queryparser-serql -f .mfiles-sesame-queryparser-serql
%files queryparser-sparql -f .mfiles-sesame-queryparser-sparql

%files queryrender -f .mfiles-sesame-queryrender

%files queryresultio -f .mfiles-sesame-queryresultio
%files queryresultio-api -f .mfiles-sesame-queryresultio-api
%files queryresultio-binary -f .mfiles-sesame-queryresultio-binary
%files queryresultio-sparqljson -f .mfiles-sesame-queryresultio-sparqljson
%files queryresultio-sparqlxml -f .mfiles-sesame-queryresultio-sparqlxml
%files queryresultio-text -f .mfiles-sesame-queryresultio-text

%files repository -f .mfiles-sesame-repository
%files repository-api -f .mfiles-sesame-repository-api
%files repository-contextaware -f .mfiles-sesame-repository-contextaware
%files repository-dataset -f .mfiles-sesame-repository-dataset
%files repository-event -f .mfiles-sesame-repository-event
%files repository-http -f .mfiles-sesame-repository-http
%files repository-manager -f .mfiles-sesame-repository-manager
%files repository-sail -f .mfiles-sesame-repository-sail
%files repository-sparql -f .mfiles-sesame-repository-sparql

%files rio -f .mfiles-sesame-rio
%files rio-api -f .mfiles-sesame-rio-api
%files rio-binary -f .mfiles-sesame-rio-binary
%files rio-datatypes -f .mfiles-sesame-rio-datatypes
%files rio-jsonld -f .mfiles-sesame-rio-jsonld
%files rio-languages -f .mfiles-sesame-rio-languages
%files rio-n3 -f .mfiles-sesame-rio-n3
%files rio-nquads -f .mfiles-sesame-rio-nquads
%files rio-ntriples -f .mfiles-sesame-rio-ntriples
%files rio-rdfjson -f .mfiles-sesame-rio-rdfjson
%files rio-rdfxml -f .mfiles-sesame-rio-rdfxml
%files rio-trig -f .mfiles-sesame-rio-trig
%files rio-trix -f .mfiles-sesame-rio-trix
%files rio-turtle -f .mfiles-sesame-rio-turtle

%files runtime -f .mfiles-sesame-runtime

%files runtime-osgi -f .mfiles-sesame-runtime-osgi

%files sail -f .mfiles-sesame-sail
%files sail-api -f .mfiles-sesame-sail-api
%files sail-base -f .mfiles-sesame-sail-base
%files sail-federation -f .mfiles-sesame-sail-federation
%files sail-fts -f .mfiles-sesame-sail-fts
%files sail-inferencer -f .mfiles-sesame-sail-inferencer
%files sail-lucene-api -f .mfiles-sesame-sail-lucene-api
%files sail-lucenesail -f .mfiles-sesame-sail-lucenesail
%files sail-memory -f .mfiles-sesame-sail-memory
%files sail-model -f .mfiles-sesame-sail-model
%files sail-nativerdf -f .mfiles-sesame-sail-nativerdf
%files sail-rdbms -f .mfiles-sesame-sail-rdbms

%files testsuites -f .mfiles-sesame-testsuites
%files geosparql-testsuite -f .mfiles-sesame-geosparql-testsuite
%files lucene-testsuite -f .mfiles-sesame-lucene-testsuite
%files model-testsuite -f .mfiles-sesame-model-testsuite
%files queryresultio-testsuite -f .mfiles-sesame-queryresultio-testsuite
%files rio-testsuite -f .mfiles-sesame-rio-testsuite
%files serql-testsuite -f .mfiles-sesame-serql-testsuite
%files sparql-testsuite -f .mfiles-sesame-sparql-testsuite
%files store-testsuite -f .mfiles-sesame-store-testsuite

%files util -f .mfiles-sesame-util
%doc README.md
%license core/LICENSE.txt core/NOTICE.txt

%files javadoc -f .mfiles-javadoc
%license core/LICENSE.txt core/NOTICE.txt

%changelog
* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 2.8.10-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Tue Mar 08 2016 gil cattaneo <puntogil@libero.it> 2.8.10-1
- update to 2.8.10

* Wed Feb 10 2016 gil cattaneo <puntogil@libero.it> 2.8.9-1
- update to 2.8.9

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 2.8.7-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Mon Nov 02 2015 gil cattaneo <puntogil@libero.it> 2.8.7-1
- update to 2.8.7

* Sat Sep 05 2015 gil cattaneo <puntogil@libero.it> 2.8.6-1
- update to 2.8.6

* Sat Aug 22 2015 gil cattaneo <puntogil@libero.it> 2.8.5-1
- update to 2.8.5

* Thu Jul 09 2015 gil cattaneo <puntogil@libero.it> 2.8.4-1
- update to 2.8.4

* Thu Jun 25 2015 gil cattaneo <puntogil@libero.it> 2.7.16-1
- initial rpm
